#!C:\Programme2\Python25\python.exe
# -*- coding: UTF-8 -*-
import os, sys, xml.dom.minidom, subprocess

# ***** include the biocase.lib directory in the python sys path for importing *****
execfile( os.path.abspath( os.path.join( os.path.dirname( __file__ ), os.pardir, os.pardir, 'lib', 'biocase', 'adjustpath.py' ) ))
execfile( os.path.abspath( os.path.join( os.path.dirname( __file__ ), os.pardir, os.pardir, 'lib', 'biocase', 'appinit.py' ) ))

from biocase.configtool.general import *
import biocase.configuration

archivefilename = form.getvalue('archivefilename')
dsa = form.getvalue('dsa')
action = form.getvalue("action")
archivePath = os.path.join(cfg.archiveWorkLocator, dsa) + os.sep
config = archivePath + archivefilename + ".config.xml"
proc = archivePath + archivefilename + ".proc"
proc_dwca = archivePath + "DwCA_1.0.proc"
log = archivePath + archivefilename + ".log"
log_dwca = archivePath + "DwCA_1.0.log"
dldPath = os.path.join(cfg.archiveDownloadLocator, dsa) + os.sep
faf = dldPath + archivefilename

if dsa is None:
    execfile( os.path.abspath( os.path.join( os.path.dirname( __file__ ), 'main.cgi' ) ))
    sys.exit()

print('Content-Type: text/html\n')

# Print 25 last lines of log files
if action == "showlog":
    # First, print log
    if os.path.exists(log):
        size = os.path.getsize(log)
        f = open(log)
        # Only read 4KB at the end, restrict output to 35 lines
        f.seek(max(size-4096, 0))
        lines = f.readlines()
        if len(lines) > 25:
            print "(continued)"
        for line in lines[-25:]:
            print line.rstrip()
        f.close()
    else:		
        print("Log file not found: " + log)

    # Add line that indicates finishing
    if not os.path.exists(proc):
        print("... processing ended.")

# Returns true if any archive is currently being processed for the DSA
# works for both XML and DwCA
if action == "isRunning":
    running = "false"
    for fname in os.listdir(archivePath):
        if fname[-5:] == ".proc":
            running = "true"
            break;
    print(running)

if action == "archiveexists":
    if os.path.exists(faf):
	print("true")
    else:
	print("false")

if action == "cancel":	
    if os.path.exists(proc):
        p = open(proc, "w")
        p.write("cancel")
        p.close()
        print "Cancellation of "+archivefilename+" requested. Waiting for the running statement to finish..."
    else:
        print(archivefilename + " is not running.")

if action == "proclist":
    j = "{ "
    l = os.listdir(archivePath)
    for f in l:
        if f.endswith(".proc"):
            j += '"' + f + '":"' + f[:-5] + '",'
    j = j[:-1] + "}"
    print j

if action == "finishedlist":
    j = "{ "
    l = os.listdir(dldPath)
    for f in l:
        if f.endswith(".zip"):
            name = f
            if not os.path.exists(archivePath + name + ".proc"):
                # Load namespace from config file
		dom = xml.dom.minidom.parse(archivePath + name + ".config.xml")
		ns = str(dom.getElementsByTagName("schemans")[0].firstChild.data)
		# return key = filename, val = namespace
                j += '"' + name + '":"' + ns + '",'
    j = j[:-1] + "}"	
    print j

if action == "remove":
    try:
        if os.path.exists(faf):
            os.remove(faf)		
        if os.path.exists(config):
            os.remove(config)
            print archivefilename+" was removed."
        else:
            print(archivefilename + " does not exist.")
    except Exception, err:
        print err

if action == 'dwca_cancel':
    q = open('/Workspace/bps2/archive/pid.txt', 'r')
    for line in q:
        id = line
    q.close()
    #os.kill(id, signal.CTRL_C_EVENT)
    print subprocess.Popen("taskkill /F /T /PID %i" % int(id) , shell=True) 
    print id

if action == "dwca":
    # Start process
    # We need to use output redirection through shell because the "logfile" option doesn't write anything in the log
    # See http://jira.pentaho.com/browse/PDI-5396 and http://jira.pentaho.com/browse/PDI-7667
    # This bug is still not solved in version 4.2.1
    args = ['java',
            '-Djava.ext.dirs=%s'                % (cfg.kettleLibLocator),
            '-Xmx%dm'                           % (1024),
            'org.pentaho.di.kitchen.Kitchen',
            '-file=%s'                          % (os.path.join(cfg.archiveLibLocator, 'dwca.kjb')),
            '-param:base_dir=%s'                % (archivePath),
            '-param:archive=%s'                 % (faf),
            '1>%s'                              % (log_dwca),
            '2>&1'] 
    #print args
    process = subprocess.Popen(args, shell=True)
    #['java', '-Djava.ext.dirs=/Workspace/bps2/lib/kettle;', '-Xmx1024m', 'org.pentaho.di.kitchen.Kitchen', '-file=C:/Workspace/bps2/lib/biocase/archive/dwca.kjb', '-param:base_dir=BoBO/', '-param:archive=/Workspace/bps2/www/downloads/BoBO/BoBO_ABCD_2.06.zip', '1>output.txt', '2>&1'], shell=True)

    # Then, write pid to file
    pid = open(proc_dwca, 'w')
    pid.write(str(process.pid))
    pid.close()

    # Waiiiiiiiiiiiiiiiiit
    process.wait()

    # Last, delete proc file
    os.remove(proc_dwca)
