#!C:\Programme2\Python25\python.exe
# -*- coding: UTF-8 -*-
import os, sys, subprocess
 
# ***** include the biocase.lib directory in the python sys path for importing *****
execfile( os.path.abspath( os.path.join( os.path.dirname( __file__ ), os.pardir, os.pardir, 'lib', 'biocase', 'adjustpath.py' ) ))
execfile( os.path.abspath( os.path.join( os.path.dirname( __file__ ), os.pardir, os.pardir, 'lib', 'biocase', 'appinit.py' ) ))

from biocase.configtool.general import *
from biocase.datasources import Datasource
import biocase.configuration

archivefilename = form.getvalue('archivefilename')
dsa = form.getvalue('dsa')
ticket = form.getvalue('ticket')
filesize = form.getvalue('filesize')
errors = form.getvalue('errors')

# check authentication!
authorize(form, dsa=dsa)
if dsa is None:
    execfile( os.path.abspath( os.path.join( os.path.dirname( __file__ ), 'main.cgi' ) ))
    sys.exit()

cfg = biocase.configuration.Cfg()
dsaObj = Datasource(name=dsa)
wrapperurl = dsaObj.getBioCASeAccessPoint()

archivePath = os.path.join(cfg.archiveWorkLocator, dsa) + os.sep
archiveBin = os.path.join(cfg.archiveLibLocator, "archive.py")
schema = form.getvalue('schema')
schemaNs = str(form.getvalue('schemafile')).encode('latin-1')
proc = archivePath + archivefilename + ".proc"

print('Content-Type: text/html\n')

try:
    q = open(archivePath + archivefilename + ".query.xml", "w")
    q.write("<?xml version='1.0' encoding='UTF-8'?>\n")
    q.write("<request xmlns='http://www.biocase.org/schemas/protocol/1.3'>\n")
    q.write("  <header><type>search</type></header>\n")
    q.write("  <search>\n")
    q.write("    <requestFormat>"+schemaNs+"</requestFormat>\n")
    q.write("    <responseFormat start='0' limit='"+filesize+"'>"+schemaNs+"</responseFormat>\n")
    q.write("    <count>false</count>\n")
    q.write("  </search>\n")
    q.write("</request>\n")
    q.close()

    c = open(archivePath + archivefilename + ".config.xml", "w")
    c.write("<?xml version='1.0' encoding='UTF-8'?>\n")
    c.write("<config>\n")
    c.write("<dsa>" + dsa + "</dsa>\n")
    c.write("<archivefilename>" + archivefilename + "</archivefilename>\n")
    c.write("<downloadfolder>" + cfg.archiveDownloadLocator + "</downloadfolder>\n")
    c.write("<ticket>" + ticket + "</ticket>\n")
    c.write("<wrapperurl>" + wrapperurl + "</wrapperurl>\n")
    c.write("<schema>"+schema+"</schema>\n")
    c.write("<schemans>"+schemaNs+"</schemans>\n")
    c.write("<consecutiveerrors>"+errors+"</consecutiveerrors>")
    c.write("</config>\n")
    c.close()

    p = subprocess.Popen([sys.executable, archiveBin, archivefilename, dsa, archivePath])

except Exception, err:
    print err
